---
title: "FreeBSD 8.4-RELEASE Release Notes"
sidenav: download
---

++++


<h3 class="corpauthor">The FreeBSD Project</h3>

<p class="copyright">Copyright &copy; 2013 The FreeBSD Documentation Project</p>

<p class="pubdate">$FreeBSD: releng/8.4/release/doc/en_US.ISO8859-1/relnotes/article.xml
251258 2013-06-02 16:21:02Z hrs $<br />
</p>

<div class="legalnotice"><a id="trademarks" name="trademarks"></a>
<p>FreeBSD is a registered trademark of the FreeBSD Foundation.</p>

<p>IBM, AIX, EtherJet, Netfinity, OS/2, PowerPC, PS/2, S/390, and ThinkPad are trademarks
of International Business Machines Corporation in the United States, other countries, or
both.</p>

<p>IEEE, POSIX, and 802 are registered trademarks of Institute of Electrical and
Electronics Engineers, Inc. in the United States.</p>

<p>Intel, Celeron, EtherExpress, i386, i486, Itanium, Pentium, and Xeon are trademarks or
registered trademarks of Intel Corporation or its subsidiaries in the United States and
other countries.</p>

<p>SPARC, SPARC64, SPARCengine, and UltraSPARC are trademarks of SPARC International, Inc
in the United States and other countries. SPARC International, Inc owns all of the SPARC
trademarks and under licensing agreements allows the proper use of these trademarks by
its members.</p>

<p>Many of the designations used by manufacturers and sellers to distinguish their
products are claimed as trademarks. Where those designations appear in this document, and
the FreeBSD Project was aware of the trademark claim, the designations have been followed
by the &#8220;&#8482;&#8221; or the &#8220;&reg;&#8221; symbol.</p>
</div>

<div>
<div class="abstract"><a id="AEN18" name="AEN18"></a>
<p>The release notes for FreeBSD 8.4-RELEASE contain a summary of the changes made to the
FreeBSD base system on the 8.4-STABLE development line. This document lists applicable
security advisories that were issued since the last release, as well as significant
changes to the FreeBSD kernel and userland. Some brief remarks on upgrading are also
presented.</p>
</div>
</div>

<hr />
</div>

<div class="TOC">
<dl>
<dt><b>Table of Contents</b></dt>

<dt>1 <a href="#intro">Introduction</a></dt>

<dt>2 <a href="#new">What's New</a></dt>

<dd>
<dl>
<dt>2.1 <a href="#security">Security Advisories</a></dt>

<dt>2.2 <a href="#kernel">Kernel Changes</a></dt>

<dd>
<dl>
<dt>2.2.1 <a href="#boot">Boot Loader Changes</a></dt>

<dt>2.2.2 <a href="#proc">Hardware Support</a></dt>

<dt>2.2.3 <a href="#net-proto">Network Protocols</a></dt>

<dt>2.2.4 <a href="#disks">Disks and Storage</a></dt>

<dt>2.2.5 <a href="#fs">File Systems</a></dt>
</dl>
</dd>

<dt>2.3 <a href="#userland">Userland Changes</a></dt>

<dd>
<dl>
<dt>2.3.1 <a href="#rcd-scripts"><tt class="filename">/etc/rc.d</tt> Scripts</a></dt>
</dl>
</dd>

<dt>2.4 <a href="#contrib">Contributed Software</a></dt>

<dt>2.5 <a href="#ports">Ports/Packages Collection Infrastructure</a></dt>

<dt>2.6 <a href="#releng">Release Engineering and Integration</a></dt>
</dl>
</dd>

<dt>3 <a href="#upgrade">Upgrading from previous releases of FreeBSD</a></dt>
</dl>
</div>

<div class="sect1">
<h2 class="sect1"><a id="intro" name="intro">1 Introduction</a></h2>

<p>This document contains the release notes for FreeBSD 8.4-RELEASE.&#09;It describes
recently added, changed, or deleted features of FreeBSD. It also provides some notes on
upgrading from previous versions of FreeBSD.</p>

<p>This distribution of FreeBSD 8.4-RELEASE is a release distribution. It can be found at
<a href="ftp://ftp.FreeBSD.org/" target="_top">ftp://ftp.FreeBSD.org/</a> or any of its
mirrors.&#09; More information on obtaining this (or other) release distributions of
FreeBSD can be found in the <a
href="../../../../doc/en_US.ISO8859-1/books/handbook/mirrors.html"
target="_top">&#8220;Obtaining FreeBSD&#8221; appendix</a> to the <a
href="../../../../doc/en_US.ISO8859-1/books/handbook/" target="_top">FreeBSD
Handbook</a>.</p>

<p>All users are encouraged to consult the release errata before installing FreeBSD. The
errata document is updated with &#8220;late-breaking&#8221; information discovered late
in the release cycle or after the release.&#09; Typically, it contains information on
known bugs, security advisories, and corrections to documentation. An up-to-date copy of
the errata for FreeBSD 8.4-RELEASE can be found on the FreeBSD Web site.</p>
</div>

<div class="sect1">
<hr />
<h2 class="sect1"><a id="new" name="new">2 What's New</a></h2>

<p>This section describes the most user-visible new or changed features in FreeBSD since
8.3-RELEASE.</p>

<p>Typical release note items document recent security advisories issued after
8.3-RELEASE, new drivers or hardware support, new commands or options, major bug fixes,
or contributed software upgrades. They may also list changes to major ports/packages or
release engineering practices. Clearly the release notes cannot list every single change
made to FreeBSD between releases; this document focuses primarily on security advisories,
user-visible changes, and major architectural improvements.</p>

<div class="sect2">
<hr />
<h3 class="sect2"><a id="security" name="security">2.1 Security Advisories</a></h3>

<p>Problems described in the following security advisories have &#09;been fixed. For more
information, consult the individual &#09;advisories available from &#09;<a
href="http://security.FreeBSD.org/" target="_top">http://security.FreeBSD.org/</a>.</p>

<div class="informaltable"><a id="AEN38" name="AEN38"></a>
<table border="0" frame="void" width="100%" class="CALSTABLE">
<col width="20%" />
<col width="20%" />
<col width="60%" />
<thead>
<tr>
<th>Advisory</th>
<th>Date</th>
<th>Topic</th>
</tr>
</thead>

<tbody>
<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-12:01.openssl.asc"
target="_top">SA-12:01.openssl</a></td>
<td>03&nbsp;May&nbsp;2012</td>
<td>
<p>OpenSSL multiple vulnerabilities</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-12:02.crypt.asc"
target="_top">SA-12:02.crypt</a></td>
<td>30&nbsp;May&nbsp;2012</td>
<td>
<p>Incorrect crypt() hashing</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-12:03.bind.asc"
target="_top">SA-12:03.bind</a></td>
<td>12&nbsp;June&nbsp;2012</td>
<td>
<p>Incorrect handling of zero-length RDATA fields in named(8)</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-12:04.sysret.asc"
target="_top">SA-12:04.sysret</a></td>
<td>12&nbsp;June&nbsp;2012</td>
<td>
<p>Privilege escalation when returning from kernel</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-12:05.bind.asc"
target="_top">SA-12:05.bind</a></td>
<td>06&nbsp;August&nbsp;2012</td>
<td>
<p>named(8) DNSSEC validation Denial of Service</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-12:06.bind.asc"
target="_top">SA-12:06.bind</a></td>
<td>22&nbsp;November&nbsp;2012</td>
<td>
<p>Multiple Denial of Service vulnerabilities with named(8)</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-12:07.hostapd.asc"
target="_top">SA-12:07.hostapd</a></td>
<td>22&nbsp;November&nbsp;2012</td>
<td>
<p>Insufficient message length validation for EAP-TLS messages</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-12:08.linux.asc"
target="_top">SA-12:08.linux</a></td>
<td>22&nbsp;November&nbsp;2012</td>
<td>
<p>Linux compatibility layer input validation error</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-13:02.libc.asc"
target="_top">SA-13:02.libc</a></td>
<td>19&nbsp;February&nbsp;2013</td>
<td>
<p>glob(3) related resource exhaustion</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-13:03.openssl.asc"
target="_top">SA-13:03.openssl</a></td>
<td>02&nbsp;April&nbsp;2013</td>
<td>
<p>OpenSSL multiple vulnerabilities</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-13:04.bind.asc"
target="_top">SA-13:04.bind</a></td>
<td>02&nbsp;April&nbsp;2013</td>
<td>
<p>BIND remote denial of service</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-13:05.nfsserver.asc"
target="_top">SA-13:05.nfsserver</a></td>
<td>29&nbsp;April&nbsp;2013</td>
<td>
<p>Insufficient input validation in the NFS server</p>
</td>
</tr>
</tbody>
</table>
</div>
</div>

<div class="sect2">
<hr />
<h3 class="sect2"><a id="kernel" name="kernel">2.2 Kernel Changes</a></h3>

<p>A bug which could cause a kernel thread &#09;to have a wrong CPU affinity
configuration has been fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=232757"
target="_top">r232757</a>]</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">loader</span>(8)</span></a>
environment variables &#09;<code class="varname">comconsole_port</code> and &#09;<code
class="varname">comconsole_pcidev</code> have been added. The &#09;former allows to set
the base address of the serial console &#09;I/O port. The later takes the string of the
format &#09;<tt class="literal"><tt class="replaceable"><i>bus</i></tt>:<tt
class="replaceable"><i>device</i></tt>:<tt class="replaceable"><i>function</i></tt>:<tt
class="replaceable"><i>[bar]</i></tt></tt> &#09;as a value and uses the serial port
attached as PCI device at &#09;the specified location for console. Both variants pass
&#09;<code class="varname">hw.uart.console</code> variable to the &#09;<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uart&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">uart</span>(4)</span></a> driver
to properly hand-over the kernel &#09;console.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=245847"
target="_top">r245847</a>]</p>

<p>A new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">loader</span>(8)</span></a>
tunable &#09;<code class="varname">hw.broken_txfifo</code> has been added to enable
&#09;workaround for old version of <b class="application">QEMU</b> &#09;and <b
class="application">Xen</b> which have a buggy emulated &#09;UART.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=246626"
target="_top">r246626</a>]</p>

<p>The &#09;<tt class="literal">F_DUPFD_CLOEXEC</tt> command for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fcntl&sektion=2&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">fcntl</span>(2)</span></a>
&#09;has been implemented. This is standardized in IEEE Std &#09;1003.1-2008 (POSIX,
Single UNIX Specification Version 4). In &#09;addition to this, <tt
class="literal">F_DUP2FD_CLOEXEC</tt> has been &#09;implemented in analogy with &#09;<tt
class="literal">F_DUP2FD</tt>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=239860"
target="_top">r239860</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=239861"
target="_top">r239861</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=filemon&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">filemon</span>(4)</span></a>
pseudo-device has &#09;been added. This allows a process to collect file operations
&#09;data of its children.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=240707"
target="_top">r240707</a>]</p>

<p>A bug in VIMAGE <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jail&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">jail</span>(8)</span></a> which
could &#09;make the network subsystem run on an wrong vnet context has been
&#09;fixed.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233584"
target="_top">r233584</a>]</p>

<p><code class="varname">debug.kdb.break_to_debugger</code> &#09;and <code
class="varname">debug.kdb.alt_break_to_debugger</code> have been &#09;added as <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">sysctl</span>(8)</span></a>
variables and loader tunables. These &#09;are disabled by default and <code
class="option">BREAK_TO_DEBUGGER</code> &#09;and <code
class="option">ALT_BREAK_TO_DEBUGGER</code> kernel options now &#09;set them enabled.
These changes allow &#09;<tt class="filename">GENERIC</tt> kernel to support
break-to-debugger &#09;capability.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235121"
target="_top">r235121</a>]</p>

<p>The FreeBSD <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sched_ule&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">sched_ule</span>(4)</span></a>
scheduler has &#09;been improved in CPU selection on systems which support SMT
&#09;(Symmetric MultiThreading, also known as HyperThreading on &#09;Intel CPUs). It now
prefers a logical CPU when the the other &#09;logical CPUs on the physical one are idle,
and an idle CPU in &#09;an SMT CPU group always has lower priority. The CPU load
&#09;calculation for load balancing has also been improved to &#09;consider highest and
lowest CPU load in comparison to &#09;differentiate load in CPU groups. This change gives
10-15% &#09;performance improvement in SMT CPUs such as Core i7.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=241246"
target="_top">r241246</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=shm_map&sektion=9&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">shm_map</span>(9)</span></a> and
&#09;<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=shm_unmap&sektion=9&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">shm_unmap</span>(9)</span></a>
functions have been added to allow in-kernel &#09;code to map portions of shared memory
objects created by &#09;<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=shm_open&sektion=2&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">shm_open</span>(2)</span></a> into
the kernel's address space.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236684"
target="_top">r236684</a>]</p>

<p>A new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">sysctl</span>(8)</span></a>
variable &#09;<code class="varname">kern.stop_scheduler_on_panic</code> has been
&#09;added. When set to <tt class="literal">1</tt>, only one thread runs
&#09;uninterruptedly after a system panic and the other CPUs are &#09;stopped. The
default value is <tt class="literal">0</tt>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235502"
target="_top">r235502</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">loader</span>(8)</span></a>
tunables &#09;<code class="varname">kern.maxtsiz</code>, &#09;<code
class="varname">kern.dfldsiz</code>, &#09;<code class="varname">kern.maxdsiz</code>,
&#09;<code class="varname">kern.dflssiz</code>, &#09;<code
class="varname">kern.maxssiz</code>, and &#09;<code class="varname">kern.sgrowsiz</code>
are now writable &#09;<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">sysctl</span>(8)</span></a>
variables.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=240502"
target="_top">r240502</a>]</p>

<p>A bug that changes to a &#09;mapped file with the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mmap&sektion=2&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">mmap</span>(2)</span></a> system
call were not flushed &#09;properly under certain circumstances has been fixed. If a
&#09;process has an NFS-backed file and adds changes to it, &#09;normally the changes are
written into the backing store &#09;automatically. However, the NFS client recognized the
&#09;modified parts are written successfully even when the write &#09;operation was
failed for some reason such as permission &#09;denied.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233765"
target="_top">r233765</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234094"
target="_top">r234094</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236150"
target="_top">r236150</a>]</p>

<div class="sect3">
<hr />
<h4 class="sect3"><a id="boot" name="boot">2.2.1 Boot Loader Changes</a></h4>

<p>[amd64, i386, pc98] A bug in &#09; FreeBSD boot block has been fixed. A pathname of
the third &#09; stage loader (or kernel) in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=boot.config&sektion=5&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">boot.config</span>(5)</span></a>
&#09; configuration file could not be recognized.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233377"
target="_top">r233377</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234563"
target="_top">r234563</a>]</p>

<p>A bug in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">loader</span>(8)</span></a> which
could &#09; prevents a UFS1 filesystem on big endian platforms from &#09; booting.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=232963"
target="_top">r232963</a>]</p>

<p>[sparc64] FreeBSD <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">loader</span>(8)</span></a> now
&#09; supports <tt class="command">heap</tt> to show the heap &#09; usage.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235998"
target="_top">r235998</a>]</p>

<p>The <b class="application">gptboot</b> &#09; boot block now reads the backup GPT
header from the last LBA &#09; only when the primary GPT header and tables are invalid.
&#09; This mitigates interoperability issues with some &#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=geom&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">geom</span>(4)</span></a>
providers like <tt class="literal">MIRROR</tt> which &#09; use the last LBA for the
metadata.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234694"
target="_top">r234694</a>]</p>

<p>[sparc64] FreeBSD/sparc64 now &#09; supports booting from ZFS via the &#09; <tt
class="filename">zfsboot</tt> boot block and &#09; <tt
class="filename">zfsloader</tt>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236077"
target="_top">r236077</a>]</p>

<p>A bug in the &#09; <b class="application">zfsboot</b> boot block which could &#09;
prevent <code class="option">-q</code> option from working has been &#09; fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234680"
target="_top">r234680</a>]</p>

<p>The <tt class="filename">zfsboot</tt> boot &#09; block and <tt
class="filename">zfsloader</tt> support filesystems &#09; within a ZFS storage pool. In
&#09; <tt class="filename">zfsloader</tt>, the ZFS device name format &#09; is now <tt
class="filename">zfs:pool/fs</tt> and the fully &#09; qualified file path format is &#09;
<tt class="filename">zfs:pool/fs:/path/to/file</tt>. The &#09; <tt
class="filename">zfsboot</tt> boot block accepts the &#09; kernel/loader name in the
format &#09; <tt class="filename">pool:fs:path/to/file</tt> or, as before, &#09; <tt
class="filename">pool:path/to/file</tt>. In the latter case &#09; a default filesystem is
used (the pool root or a filesystem &#09; with the bootfs property). The <tt
class="filename">zfsboot</tt> &#09; boot block passes the GUIDs of the selected storage
pool and &#09; dataset to <tt class="filename">zfsloader</tt> to be used as its &#09;
defaults.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=237765"
target="_top">r237765</a>]</p>
</div>

<div class="sect3">
<hr />
<h4 class="sect3"><a id="proc" name="proc">2.2.2 Hardware Support</a></h4>

<p>FreeBSD <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=acpi&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">acpi</span>(4)</span></a>
subsystem now uses &#09; MADT to match ACPI Processor objects to CPUs and ignores &#09;
disabled cores while it is possible that MADT and DSDT/SSDTs &#09; may list CPUs in
different orders. A new loader tunable &#09; <code
class="varname">debug.acpi.cpu_unordered</code> has been added &#09; for buggy systems
that do not have unique ACPI IDs for MADT &#09; and Processor objects. Setting it to <tt
class="literal">1</tt> &#09; restores the old behavior.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=237823"
target="_top">r237823</a>]</p>

<p>[amd64] A workaround for Erratum &#09; 721 for AMD Processor Family 10h and 12h has
been &#09; implemented. Under a highly specific and detailed set of &#09; internal timing
conditions, the processor may incorrectly &#09; update the stack pointer after a long
series of push and/or &#09; near-call instructions, or a long series of pop and/or &#09;
near-return instructions.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233799"
target="_top">r233799</a>]</p>

<p>[amd64] The extended FPU states &#09; for native 64-bit and 32-bit ABIs have been
supported. AVX &#09; instructions are also enabled on capable CPUs.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=237009"
target="_top">r237009</a>]</p>

<p>[amd64, i386, pc98] The &#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=atkbdc&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">atkbdc</span>(4)</span></a> driver
now supports a keyboard controller &#09; which has PnP ID <tt
class="literal">PNP0320</tt>. This can be &#09; found on machines which have Japanese
PS/2 keyboard with &#09; 106/109 keys.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233795"
target="_top">r233795</a>]</p>

<p>[amd64, i386, pc98] The &#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=atkbdc&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">atkbdc</span>(4)</span></a> driver
now supports Synaptics touchpad v7.5 &#09; and above.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=244982"
target="_top">r244982</a>]</p>

<p>A bug in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpufreq&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">cpufreq</span>(4)</span></a> which
could &#09; prevent CPU frequency tuning from working properly has been &#09; fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233369"
target="_top">r233369</a>]</p>

<p>A bug in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hwpmc&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">hwpmc</span>(4)</span></a> driver
which &#09; could cause a deadlock in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pmcstat&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">pmcstat</span>(8)</span></a>
utility has been &#09; fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233825"
target="_top">r233825</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pcf8563&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">pcf8563</span>(4)</span></a>
driver for the NXP &#09; (Philips) PCF8563 RTC has been added.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236079"
target="_top">r236079</a>]</p>

<p>[amd64] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pci&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">pci</span>(4)</span></a> driver
&#09; now supports mapping between MSI (Message Signaled Interrupt) &#09; and
HyperTransport interrupt messages on HyperTransport to PCI &#09; bus briges. This change
improves handling of MSIs on AMD &#09; CPUs.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234151"
target="_top">r234151</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=puc&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">puc</span>(4)</span></a> &#09;
driver now supports Sun 1040 PCI Quad Serial, Moxa PCIe &#09;
CP102E/CP102EL/CP104EL-A/CP104JU/CP114EL/CP118EL-A/CP168EL-A &#09; multiport serial
boards, Advantech PCI-1602 RS-485/RS-422 &#09; serial card, and Sunix SER5437A dual
serial PCI Express &#09; card.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236651"
target="_top">r236651</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=238775"
target="_top">r238775</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=243009"
target="_top">r243009</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=248041"
target="_top">r248041</a>]</p>

<p>[amd64, i386] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=random&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">random</span>(4)</span></a> &#09;
driver now supports VIA C3 Nehemiah random number generator &#09; on VIA Nano processors.
<code class="option">PADLOCK</code> kernel &#09; option has been replaced with <code
class="option">PADLOCK_RNG</code> &#09; in <tt class="filename">GENERIC</tt> kernel.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=240991"
target="_top">r240991</a>]</p>

<p>[amd64, i386] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=random&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">random</span>(4)</span></a> &#09;
driver now supports <tt class="literal">RDRAND</tt> instruction on &#09; Intel on-chip
Digital Random Number Generator (called Bull &#09; Mountain). <code
class="option">RDRAND_RND</code> kernel option has been &#09; added to <tt
class="filename">GENERIC</tt> kernel.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=240994"
target="_top">r240994</a>]</p>

<p>A new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=syscons&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">syscons</span>(4)</span></a>
keyboard map for &#09; Danish ISO-8859-1 keyboard found on Apple MacBook has been &#09;
added.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=242338"
target="_top">r242338</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=syscons&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">syscons</span>(4)</span></a>
driver &#09; has been fixed. It could cause a button of a USB mouse to &#09; be pressed
and never released after detaching.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=246787"
target="_top">r246787</a>]</p>

<p>[amd64, i386] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uart&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">uart</span>(4)</span></a> &#09;
driver now supports Intel AMT Serial Port for Remote &#09; Keyboard and Text (KT)
Redirection (Serial Over LAN) on &#09; Intel 4 Series Chipset family.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233065"
target="_top">r233065</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uart&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">uart</span>(4)</span></a> driver
&#09; now supports Wacom Tablet at FuS Lifebook T, multiport &#09; serial device IrDA
devices with PnP ID PNP0502, PNP0510, and &#09; PNP0511, V.34 modems based on CIR1000
Cirrus Logic chip, and &#09; MosChip MCS9904 four serial ports controller.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=242883"
target="_top">r242883</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=243357"
target="_top">r243357</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=244140"
target="_top">r244140</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uftdi&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">uftdi</span>(4)</span></a> driver
now &#09; supports BeagleBone and FT2232-based egnite Turtelizer 2 &#09; JTAG/RS232
Adapter.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=237189"
target="_top">r237189</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=237381"
target="_top">r237381</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uchcom&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">uchcom</span>(4)</span></a> driver
now supports &#09; CH341/CH340 USB-Serial Bridge.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=240570"
target="_top">r240570</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ukbd&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">ukbd</span>(4)</span></a> driver
now supports &#09; Microsoft Natural Ergonomic Keyboard 4000. It had an issue &#09; that
function keys were not recognized.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=239426"
target="_top">r239426</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uplcom&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">uplcom</span>(4)</span></a> driver
now supports &#09; Motorola cable.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=239726"
target="_top">r239726</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=usb&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">usb</span>(4)</span></a> driver
now handles &#09; suspend events synchronously. This fixed problems of &#09; suspend and
resume.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=232871"
target="_top">r232871</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=usb&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">usb</span>(4)</span></a> driver
now supports &#09; multi-TT mode operation, which can have one transaction &#09;
translator for each downstream-facing port on a USB hub. &#09; This allows more bandwidth
for isochronous FULL speed &#09; application connected through a High Speed USB HUB.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235011"
target="_top">r235011</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uslcom&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">uslcom</span>(4)</span></a> driver
now &#09; supports Silicon Laboratories CP2103/CP2104/CP2105 based USB &#09; serial
adapter.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=239820"
target="_top">r239820</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=239827"
target="_top">r239827</a>]</p>

<p>[amd64, i386] The &#09; paravirtualized <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=virtio&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">virtio</span>(4)</span></a>
drivers have been added to &#09; <tt class="filename">GENERIC</tt> kernel. They include
PCI &#09; fontend, <tt class="literal">net</tt>, <tt class="literal">block</tt>, &#09;
<tt class="literal">balloon</tt>, and <tt class="literal">scsi</tt> &#09; drivers. The
module files are &#09; <tt class="filename">virtio.ko</tt>, &#09; <tt
class="filename">virtio_pci.ko</tt>, &#09; <tt class="filename">if_vtnet.ko</tt>, &#09;
<tt class="filename">virtio_blk.ko</tt>, &#09; <tt
class="filename">virtio_balloon.ko</tt>, and &#09; <tt
class="filename">virtio_scsi.ko</tt>, respectively.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=239473"
target="_top">r239473</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=247907"
target="_top">r247907</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=247909"
target="_top">r247909</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=wbwd&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">wbwd</span>(4)</span></a> driver,
which &#09; supports the watchdog timer found in Winbond Super I/O &#09; chips, has been
added.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235947"
target="_top">r235947</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=xhci&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">xhci</span>(4)</span></a> USB
driver now &#09; supports XHCI port routing on Intel 7 Series chipsets &#09; (Panther
Point) and Intel 8 Series chipsets (Lynx Point). A &#09; new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">loader</span>(8)</span></a>
tunable &#09; <code class="varname">hw.usb.xhci.xhci_port_route</code> has been &#09;
added for routing bitmap for switching EHCI ports to XHCI &#09; controller.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=242985"
target="_top">r242985</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=xhci&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">xhci</span>(4)</span></a> USB
driver now &#09; supports Etron EJ168 USB 3.0 Host Controllers.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=245736"
target="_top">r245736</a>]</p>

<div class="sect4">
<hr />
<h5 class="sect4"><a id="mm" name="mm">2.2.2.1 Multimedia Support</a></h5>

<p>[i386] A bug in the &#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snd_emu10kx&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">snd_emu10kx</span>(4)</span></a>
driver which could prevent it from &#09; working with <code class="option">PAE</code>
kernel option has been &#09; fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=238674"
target="_top">r238674</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snd_hda&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">snd_hda</span>(4)</span></a>
driver &#09; has been updated. It now supports and provides HDMI, new &#09; volume
control, automatic recording source selection, &#09; runtime reconfiguration, more than 4
PCM devices on a &#09; controller, multichannel recording, additional &#09;
playback/record streams, higher bandwidth, and more &#09; informative device names.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236750"
target="_top">r236750</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236753"
target="_top">r236753</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snd_uaudio&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">snd_uaudio</span>(4)</span></a>
driver now &#09; supports USB Audio v2.0.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=242983"
target="_top">r242983</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snd_uaudio&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">snd_uaudio</span>(4)</span></a>
driver now &#09; supports Intel 8 Series chipsets (Lynx Point).[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=247121"
target="_top">r247121</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snd_uaudio&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">snd_uaudio</span>(4)</span></a>
driver now &#09; supports various Yamaha keyboards.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=244248"
target="_top">r244248</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snd_uaudio&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">snd_uaudio</span>(4)</span></a>
driver now &#09; supports buttons such as volume up/down.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=246788"
target="_top">r246788</a>]</p>
</div>

<div class="sect4">
<hr />
<h5 class="sect4"><a id="net-if" name="net-if">2.2.2.2 Network Interface Support</a></h5>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=age&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">age</span>(4)</span></a> network
interface &#09; driver now supports jumbo frames.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=246725"
target="_top">r246725</a>]</p>

<p>Link state change handling in the &#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ale&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">ale</span>(4)</span></a> network
interface driver has been improved.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234127"
target="_top">r234127</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ale&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">ale</span>(4)</span></a> network
interface driver now &#09; supports flow control.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234241"
target="_top">r234241</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bce&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">bce</span>(4)</span></a> network
&#09; interface driver has been fixed. It could prevent jumbo frame &#09; configuration
from working.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235424"
target="_top">r235424</a>]</p>

<p>A bug in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bce&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">bce</span>(4)</span></a> which
could &#09; prevent IPMI (Intelligent Platform Management Interface) &#09; from working
when the interface is down has been &#09; fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236217"
target="_top">r236217</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bce&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">bce</span>(4)</span></a> network
interface driver now &#09; supports remote PHYs, which allow the controller to perform
&#09; MDIO type accesses to a remote transceiver by using message &#09; pages defined
through MRBE (MultiRate Backplane &#09; Ethernet). This is found on machines such as the
Dell &#09; PowerEdge M610 Blade.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235819"
target="_top">r235819</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bge&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">bge</span>(4)</span></a> network
&#09; interface driver which could cause watchdog timeout on BCM5704 &#09; controller
connected behind AMD 8131 PCI-X bridge has been &#09; fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233496"
target="_top">r233496</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bge&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">bge</span>(4)</span></a> driver
now &#09; supports &#09; BCM5717/5718/5719/5720/5761/57766 controllers.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=243547"
target="_top">r243547</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=245152"
target="_top">r245152</a>]</p>

<p>A bug in &#09; <code class="varname">if_ierrors</code> counter in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bge&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">bge</span>(4)</span></a> &#09;
driver running on BCM5700, 5701, 5702, 5703, or 5704 &#09; controller has been fixed. It
reported only the number of &#09; discarded packets.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233499"
target="_top">r233499</a>]</p>

<p>A bug in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bge&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">bge</span>(4)</span></a> which
could &#09; make the device stop working has been fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236219"
target="_top">r236219</a>]</p>

<p>[amd64, i386, pc98] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cas&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">cas</span>(4)</span></a>, &#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gem&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">gem</span>(4)</span></a>, and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hme&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">hme</span>(4)</span></a> drivers
have been added to &#09; <tt class="filename">GENERIC</tt> kernel.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233744"
target="_top">r233744</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cxgbe&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">cxgbe</span>(4)</span></a> network
interface &#09; driver has been updated to firmware version 1.8.4.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=247670"
target="_top">r247670</a>]</p>

<p>A bug in statistics counters in the &#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=em&sektion=4&manpath=FreeBSD+8.4-RELEASE"><span
 class="citerefentry"><span class="refentrytitle">em</span>(4)</span></a>, lem(4), and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=igb&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">igb</span>(4)</span></a> drivers
has been &#09; fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=241376"
target="_top">r241376</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=em&sektion=4&manpath=FreeBSD+8.4-RELEASE"><span
 class="citerefentry"><span class="refentrytitle">em</span>(4)</span></a> and lem(4)
network &#09; interface drivers have been updated to version 7.3.7 and &#09; 2.3.9,
respectively. It now supports Intel 82580 and &#09; I210/I217/I218 interfaces.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=247430"
target="_top">r247430</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fxp&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">fxp</span>(4)</span></a> network
interface driver has &#09; been improved. It does not cause unnecessary media change
&#09; in controller reconfiguration such as promiscuous mode &#09; change which leads to
an extra link &#09; reestablishment.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233502"
target="_top">r233502</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=igb&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">igb</span>(4)</span></a> network
interface driver now &#09; attempts to attach as many CPUs as possible to each queue.
&#09; If the number of CPUs are greater than or equal to the &#09; number of queues, all
queues are bound to different &#09; CPUs.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235616"
target="_top">r235616</a>]</p>

<p>The ipheth(4) driver now supports &#09; Apple iPhone 5 tethering mode.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=242279"
target="_top">r242279</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=iwn&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">iwn</span>(4)</span></a> driver
now &#09; supports Intel Centrino 6150 wireless N and WiMAX &#09; chipsets, and Intel
Centrino Wireless-N 100/130 &#09; devices.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233839"
target="_top">r233839</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235844"
target="_top">r235844</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ixgbe&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">ixgbe</span>(4)</span></a> network
interface &#09; driver has been updated to version 1.1.4.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=247501"
target="_top">r247501</a>]</p>

<p>A bug in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ixgbe&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">ixgbe</span>(4)</span></a> network
&#09; interface driver has been fixed. It could cause packet loss in &#09; TCP
communication when TSO (TCP Segmentation Offload) is &#09; enabled.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235666"
target="_top">r235666</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mxge&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">mxge</span>(4)</span></a> driver
has been &#09; updated to firmware version 1.4.55 from Myricom.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236416"
target="_top">r236416</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=oce&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">oce</span>(4)</span></a> network
interface &#09; driver has been updated to version 4.6.95.0.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=248062"
target="_top">r248062</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ral&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">ral</span>(4)</span></a> network
interface driver now &#09; supports Ralink RT2800 and RT3000 chipsets.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236008"
target="_top">r236008</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=re&sektion=4&manpath=FreeBSD+8.4-RELEASE"><span
 class="citerefentry"><span class="refentrytitle">re</span>(4)</span></a> and &#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rl&sektion=4&manpath=FreeBSD+8.4-RELEASE"><span
 class="citerefentry"><span class="refentrytitle">rl</span>(4)</span></a> network
interface drivers which could cause a problem on &#09; RTL8139 family has been fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233490"
target="_top">r233490</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=re&sektion=4&manpath=FreeBSD+8.4-RELEASE"><span
 class="citerefentry"><span class="refentrytitle">re</span>(4)</span></a> network &#09;
interface driver which could cause intermittent link up/down on &#09; RTL8169 controller
has been fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233493"
target="_top">r233493</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rl&sektion=4&manpath=FreeBSD+8.4-RELEASE"><span
 class="citerefentry"><span class="refentrytitle">rl</span>(4)</span></a> network
interface &#09; driver now supports D-Link DFE-520TX rev C1.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=245858"
target="_top">r245858</a>]</p>

<p>WoL (Wake-on-LAN) support &#09; in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rl&sektion=4&manpath=FreeBSD+8.4-RELEASE"><span
 class="citerefentry"><span class="refentrytitle">rl</span>(4)</span></a> driver is now
disabled by &#09; default.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233490"
target="_top">r233490</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=run&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">run</span>(4)</span></a> driver
now supports &#09; Logitec LAN-W300NU2.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=232594"
target="_top">r232594</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=run&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">run</span>(4)</span></a> network
interface driver now &#09; loads the firmware upon initialization, not attachment. &#09;
This fixes an issue when the root filesystem is not &#09; available at the time of device
detection.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233461"
target="_top">r233461</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=run&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">run</span>(4)</span></a> driver
has been &#09; updated to firmware version 0.236.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234029"
target="_top">r234029</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sf&sektion=4&manpath=FreeBSD+8.4-RELEASE"><span
 class="citerefentry"><span class="refentrytitle">sf</span>(4)</span></a> network
interface driver has &#09; been improved. System load fluctuation under high network
&#09; load has been fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233487"
target="_top">r233487</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tap&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">tap</span>(4)</span></a> pseudo
network &#09; interface driver now supports VIMAGE <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jail&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">jail</span>(8)</span></a>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=237145"
target="_top">r237145</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=u3g&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">u3g</span>(4)</span></a> driver
&#09; now supports Qualcomm Vertex Wireless 110L modem, Qualcomm &#09; 3G modem, Qualcomm
Vertex VW110L modem, SIMCom SIM5218, &#09; and Huawei K4505, K3770, E3131, E392, E3131,
K3765, K4505, &#09; and ETS2055 3G modems.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=232875"
target="_top">r232875</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235012"
target="_top">r235012</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=243655"
target="_top">r243655</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=udav&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">udav</span>(4)</span></a> network
interface &#09; driver now supports JP1082 USB-LAN adapter.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=242984"
target="_top">r242984</a>]</p>
</div>
</div>

<div class="sect3">
<hr />
<h4 class="sect3"><a id="net-proto" name="net-proto">2.2.3 Network Protocols</a></h4>

<p>Locking performance of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bpf&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">bpf</span>(4)</span></a> &#09;
Berkeley Packet Filter has been improved.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=247732"
target="_top">r247732</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=if_bridge&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">if_bridge</span>(4)</span></a>
pseudo network &#09; interface driver now supports multiple bridges in the same &#09; STP
domain. It used the same MAC address as the bridge ID &#09; for all bridges on the system
before.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236056"
target="_top">r236056</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=if_bridge&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">if_bridge</span>(4)</span></a> now
supports &#09; link state change notification and works with <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=carp&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">carp</span>(4)</span></a> &#09;
protocol.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236058"
target="_top">r236058</a>]</p>

<p>The <code class="varname">net.link.bridge</code> &#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">sysctl</span>(8)</span></a>
variables can now be set in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">loader</span>(8)</span></a> and/or
&#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader.conf&sektion=5&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span
class="refentrytitle">loader.conf</span>(5)</span></a>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236072"
target="_top">r236072</a>]</p>

<p>The default number of the bridge &#09; forwarding cache entries of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=if_bridge&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">if_bridge</span>(4)</span></a>
pseudo &#09; network interface driver has been increased from &#09; <tt
class="literal">100</tt> to <tt class="literal">2000</tt>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233085"
target="_top">r233085</a>]</p>

<p>The <tt class="literal">table</tt> argument &#09; in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">ipfw</span>(4)</span></a> packet
filter rule syntax now supports &#09; IP address, interface name, port number, and jail
ID. The &#09; following syntax is valid:</p>

<pre class="programlisting">
skipto tablearg ip from any to any via table(42) in
</pre>

<p>A new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">sysctl</span>(8)</span></a>
variable &#09; <code class="varname">net.inet.ip.fw.tables_max</code> has been added
&#09; to specify the maximum number of tables. The default value &#09; is <tt
class="literal">128</tt>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234637"
target="_top">r234637</a>]</p>

<p><tt class="literal">IP_RECVTOS</tt> socket &#09; option to receive for received
UDP/IPv4 packets a cmsg of type &#09; IP_RECVTOS which contains the TOS byte has been
implemented. &#09; This allows access to the ECN bits in a protocol on top of UDP.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=247944"
target="_top">r247944</a>]</p>

<p>A bug in FreeBSD IPv6 stack has been &#09; fixed. It could cause a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=vlan&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">vlan</span>(4)</span></a> pseudo
network &#09; interface to get the EUI64 part in an autoconfigured IPv6 &#09; address
from an unrelated Ethernet interface on the &#09; system.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233112"
target="_top">r233112</a>]</p>

<p>FreeBSD IPv6 stack now supports multiple &#09; FIBs. One can use <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=setfib&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">setfib</span>(1)</span></a> to
select a different &#09; routing table for IPv6.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=232552"
target="_top">r232552</a>]</p>

<p>A bug in reference &#09; counting of IPv6 interface routes has been fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236609"
target="_top">r236609</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236611"
target="_top">r236611</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236827"
target="_top">r236827</a>]</p>

<p>FreeBSD IPv6 stack now handles fragment &#09; packets which are not actually fragments
but have Fragment &#09; Header with both the <tt class="literal">Fragment Offset</tt> and
&#09; the <tt class="literal">M</tt> bit set to <tt class="literal">0</tt> as &#09; a
regular (non-fragment) packet. For more detail, see &#09; Internet Draft &#09; <tt
class="filename">draft-gont-6man-ipv6-atomic-fragments</tt>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=238495"
target="_top">r238495</a>]</p>

<p>A bug which could cause a system panic &#09; in the multicast routing in kernel with
<code class="option">VIMAGE</code> &#09; kernel option has been fixed. This option is
disabled in &#09; <tt class="filename">GENERIC</tt> kernel.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233605"
target="_top">r233605</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=lagg&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">lagg</span>(4)</span></a> pseudo
network &#09; driver now allows the configuration of which layers are used for the load
&#09; balance hash calculation. It can be set in &#09; <tt class="command">ifconfig
lagghash</tt> option in a &#09; comma-separated list. The default value is <code
class="option">lagghash &#09; l2,l3,l4</code>. For more detail, see <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">ifconfig</span>(8)</span></a>
&#09; manual page.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236057"
target="_top">r236057</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=lagg&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">lagg</span>(4)</span></a> pseudo
&#09; network interface driver which could cause an unexpected &#09; removal of a member
interface upon interface renaming has been &#09; fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=238048"
target="_top">r238048</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_netflow&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">ng_netflow</span>(4)</span></a>
&#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=netgraph&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">netgraph</span>(4)</span></a> node
and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=flowctl&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">flowctl</span>(8)</span></a>
utility now &#09; supports NetFlow version 9. A new export9 hook has been &#09; added for
NetFlow v9 data. Note that data export can be &#09; done simultaneously in both version 5
and version 9.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=238619"
target="_top">r238619</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=238620"
target="_top">r238620</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_patch&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">ng_patch</span>(4)</span></a>
&#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=netgraph&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">netgraph</span>(4)</span></a> node
which could cause a system panic has &#09; been fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234682"
target="_top">r234682</a>]</p>

<p>FreeBSD routing table handling has been &#09; improved. It can now perform packet
forwarding even while a &#09; user application is reading the whole routing table via
&#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">sysctl</span>(8)</span></a>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235056"
target="_top">r235056</a>]</p>

<p>A loader tunable &#09; <code class="varname">net.fibs</code> now supports specifying
the &#09; number of routing tables. The <code class="option">ROUTETABLES</code> &#09;
kernel option can still be used to set the default number of &#09; routing tables.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235104"
target="_top">r235104</a>]</p>

<p>FreeBSD SCTP stack now supports &#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_iface&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">ng_iface</span>(4)</span></a> and
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=stf&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">stf</span>(4)</span></a>
interfaces.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233245"
target="_top">r233245</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233246"
target="_top">r233246</a>]</p>

<p>FreeBSD SCTP stack now supports &#09; <code
class="varname">net.inet.udp.checksum</code> <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">sysctl</span>(8)</span></a> &#09;
variable for SCTP over UDP over IPv4 encapsulation.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234805"
target="_top">r234805</a>]</p>

<p><tt class="literal">SO_PROTOCOL</tt> and &#09; <tt class="literal">SO_PROTOTYPE</tt>
socket option have been &#09; added. These are socket level options to get the protocol
&#09; number found in <b class="application">Linux</b> or &#09; <b
class="application">Solaris</b>. For more detail, see &#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=setsockopt&sektion=2&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">setsockopt</span>(2)</span></a>
manual page.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=232819"
target="_top">r232819</a>]</p>

<p>An issue in FreeBSD <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tcp&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">tcp</span>(4)</span></a> host
&#09; cache has been fixed. It could cause extra ICMP message &#09; exchanges when an
ICMP unreach is received but allocation of &#09; the corresponding TCP host cache
fails.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235053"
target="_top">r235053</a>]</p>

<p>A <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">sysctl</span>(8)</span></a>
variable &#09; <code class="varname">net.inet.tcp.rexmit_drop_options</code> has been
&#09; added to not drop options from the third retransmitted SYN. &#09; The default value
is set to <tt class="literal">1</tt> for &#09; backward compatibility.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=247499"
target="_top">r247499</a>]</p>
</div>

<div class="sect3">
<hr />
<h4 class="sect3"><a id="disks" name="disks">2.2.4 Disks and Storage</a></h4>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ahci&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">ahci</span>(4)</span></a> driver
now supports &#09; Marvell 88SE9220/9230/9235 PCIe 2.0 x2 6Gbps SATA &#09;
controllers.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=237114"
target="_top">r237114</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=arcmsr&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">arcmsr</span>(4)</span></a> driver
has &#09; been updated to version 1.20.00.26 and now supports &#09; ARC-1214 and
ARC-1224.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=244923"
target="_top">r244923</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=247827"
target="_top">r247827</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=amr&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">amr</span>(4)</span></a> driver
which &#09; could cause data corruption has been fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236319"
target="_top">r236319</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">ata</span>(4)</span></a> driver
now supports &#09; Intel 8 Series chipsets (Lynx Point).[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=247099"
target="_top">r247099</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">ata</span>(4)</span></a> driver
now creates &#09; symbolic links for backward compatibility when &#09; <code
class="option">ATA_CAM</code> kernel option is enabled. In a &#09; kernel with <code
class="option">ATA_CAM</code>, an ATA/SATA disk is &#09; recognized as a device node with
a name &#09; <tt class="filename">ada0</tt> instead of &#09; <tt
class="filename">ad0</tt>. A symbolic link &#09; <tt class="filename">/dev/ad0</tt> is
automatically generated for &#09; <tt class="filename">/dev/ada0</tt> to keep backward
&#09; compatibility. This symbolic link generation can be &#09; controlled by a &#09;
<code class="varname">kern.cam.ada.legacy_aliases</code> (enabled by &#09; default when
<code class="option">ATA_CAM</code> is set).[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234912"
target="_top">r234912</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">ata</span>(4)</span></a> driver
now has &#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">loader</span>(8)</span></a>
tunables to set initial SATA revision for the &#09; specific device. The tunable name is
&#09; <code class="varname">hint.ata.<tt class="replaceable"><i>busnum</i></tt>.dev<tt
class="replaceable"><i>devnum</i></tt>.sata_rev</code> &#09; for a device <tt
class="replaceable"><i>devnum</i></tt> on a bus &#09; <tt
class="replaceable"><i>busnum</i></tt>, or &#09; <code class="varname">hint.ata.<tt
class="replaceable"><i>busnum</i></tt>.sata_rev</code> &#09; for all devices on a bus <tt
class="replaceable"><i>busnum</i></tt>. &#09; The valid values are <tt
class="literal">1</tt>, &#09; <tt class="literal">2</tt>, and <tt class="literal">3</tt>,
which &#09; correspond to 1.5&nbsp;Gbps, 3&nbsp;Gbps, and &#09; 6&nbsp;Gbps.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=243124"
target="_top">r243124</a>]</p>

<p>A new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">sysctl</span>(8)</span></a> &#09;
<code class="varname">kern.features.ata_cam</code> has been added. &#09; This shows
whether <tt class="literal">ATA_CAM</tt> kernel option &#09; is enabled or not. This
option is disabled in &#09; <tt class="filename">GENERIC</tt> kernel.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233714"
target="_top">r233714</a>]</p>

<p>A new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">sysctl</span>(8)</span></a>
variable &#09; <code class="varname">kern.cam.pmp.hide_special</code> has been added.
&#09; This controls whether special PMP ports such as PMP (Port &#09; MultiPlier)
configuration or SEMB (SATA Enclosure Management &#09; Bridge) will be exposed or hidden.
The default value is &#09; <tt class="literal">1</tt> (hidden).[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236766"
target="_top">r236766</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cam&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">cam</span>(4)</span></a> driver
now uses &#09; <tt class="literal">READ CAPACITY(16)</tt> SCSI command to get &#09;
device information by default when possible. This enables &#09; to detect whether Logical
Block Provisioning (also known as &#09; <tt class="literal">TRIM</tt> or <tt
class="literal">UNMAP</tt>) in &#09; SBC-3 (SCSI Block Commands-3) Specification is
supported on &#09; the device.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=232942"
target="_top">r232942</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236804"
target="_top">r236804</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">sysctl</span>(8)</span></a>
variables &#09; <code class="varname">kern.cam.da.da_send_ordered</code> and &#09; <code
class="varname">kern.cam.ada.ada_send_ordered</code> have been &#09; renamed with <code
class="varname">kern.cam.da.send_ordered</code> and &#09; <code
class="varname">kern.cam.ada.send_ordered</code>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=247105"
target="_top">r247105</a>]</p>

<p>Performance of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=da&sektion=4&manpath=FreeBSD+8.4-RELEASE"><span
 class="citerefentry"><span class="refentrytitle">da</span>(4)</span></a> driver &#09;
has been improved. It now handles subsequent &#09; <tt class="literal">BIO_DELETE</tt>
requests handled as a single &#09; <tt class="literal">TRIM</tt> request.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234914"
target="_top">r234914</a>]</p>

<p>[amd64, i386] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hpt27xx&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">hpt27xx</span>(4)</span></a> &#09;
driver has been included in <tt class="filename">GENERIC</tt> &#09; kernel.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=245941"
target="_top">r245941</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hptiop&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">hptiop</span>(4)</span></a> driver
has &#09; been updated to version 1.8 and now supports HighPoint &#09; RocketRAID
4500/4311/4310/4211/4210/3560/3530.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=239159"
target="_top">r239159</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=242216"
target="_top">r242216</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=isci&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">isci</span>(4)</span></a> driver
now supports &#09; Intel C600 Serial Attached SCSI controllers with chip IDs from &#09;
<tt class="literal">0x1d6c</tt> to <tt class="literal">0x1d6f</tt>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=232554"
target="_top">r232554</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=isci&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">isci</span>(4)</span></a> driver
which &#09; could not correctly handle <tt class="literal">READ &#09; CAPACITY(16)</tt>
SCSI command for an SATA device has &#09; been fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233789"
target="_top">r233789</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=isci&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">isci</span>(4)</span></a> driver
now supports &#09; SCSI UNMAP to ATA DSM translation.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=239735"
target="_top">r239735</a>]</p>

<p>A bug in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=isci&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">isci</span>(4)</span></a> driver
which &#09; could prevent <b class="application">smartctl</b> &#09; (<tt
class="filename">sysutils/smartmontools</tt> in the Ports &#09; Collection) from
working.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236264"
target="_top">r236264</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mfi&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">mfi</span>(4)</span></a> driver
now supports &#09; LSI MegaRAID SAS cards named "Drake Skinny" and &#09; "ThunderBolt".
This includes Dell PERC H810/H800/H710/H700 &#09; and Intel RAID Controller
RS25DB080/RS25NB008.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235625"
target="_top">r235625</a>]</p>

<p>A bug which could make the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mpt&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">mpt</span>(4)</span></a> &#09;
driver attach LSI MegaRAID cards which should be handled by &#09; the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mfi&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">mfi</span>(4)</span></a> driver
has been fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=232563"
target="_top">r232563</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mfi&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">mfi</span>(4)</span></a> driver
now supports &#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">loader</span>(8)</span></a>
tunable &#09; <code class="varname">hw.mfi.allow_cam_disk_passthrough</code> to &#09;
control raw disk attachment. The default value is &#09; <tt class="literal">0</tt>
(disabled).[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=243826"
target="_top">r243826</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mps&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">mps</span>(4)</span></a> driver
has been &#09; updated to version 14.00.00.01-fbsd. This now supports &#09; Integrated
RAID, WarpDrive controllers, &#09; <tt class="literal">WRITE12</tt> and <tt
class="literal">READ12</tt> for &#09; direct I/O, SCSI protection information (EEDP),
Transport &#09; Level Retries (TLR) for tape drives, and LSI's userland &#09; utility.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=237877"
target="_top">r237877</a>]</p>

<p>[sparc64, powerpc] The &#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mps&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">mps</span>(4)</span></a> driver
has been added to &#09; <tt class="filename">GENERIC</tt> kernel.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=237944"
target="_top">r237944</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=238074"
target="_top">r238074</a>]</p>

<p>The <tt class="literal">MULTIPATH</tt> &#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=geom&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">geom</span>(4)</span></a> class
has been updated. It now supports &#09; Active/Active mode, Active/Read mode as hybrid of
&#09; Active/Active and Active/Passive, keeping a failed path &#09; without removing the
geom provider, manual configuration &#09; without on-disk metadata, and add, remove,
fail, restore, &#09; configure subcommands in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gmultipath&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">gmultipath</span>(8)</span></a>
utility to &#09; manage the configured paths.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234917"
target="_top">r234917</a>]</p>

<p>The <tt class="literal">PART_LDM</tt> &#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=geom&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">geom</span>(4)</span></a> class
has been added. This partition scheme has &#09; support for Logical Disk Manager, which
is also known as &#09; dynamic volumes in Microsoft Windows NT. Note that JBOD, &#09;
RAID0, and RAID5 volumes are not supported yet.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234407"
target="_top">r234407</a>]</p>

<p>The <tt class="literal">RAID</tt> &#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=geom&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">geom</span>(4)</span></a> class
now supports the DDF metadata format, &#09; which is defined in the SNIA Common RAID Disk
Data Format &#09; Specification v2.0. It can read non-degraded &#09;
RAID4/5/5E/5EE/5R/6/MDF volumes. An <code class="option">-o</code> &#09; option in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=graid&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">graid</span>(8)</span></a> utility
can be used to specify byte &#09; order for the DDF metadata.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235875"
target="_top">r235875</a>]</p>

<p>The <tt class="literal">RAID</tt> &#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=geom&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">geom</span>(4)</span></a> class
now partially supports Intel Rapid &#09; Recover Technology (Intel RRT). It is alike to
RAID1, but &#09; with dedicating master and recovery disks and providing &#09; manual
control over synchronization. It allows to use &#09; recovery disk as snapshot of the
master disk from the time &#09; of the last sync.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=246170"
target="_top">r246170</a>]</p>

<p>The <tt class="literal">RAID</tt> &#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=geom&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">geom</span>(4)</span></a> class
now supports <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">sysctl</span>(8)</span></a>
variables &#09; <code class="varname">kern.geom.raid.enable</code> and &#09; <code
class="varname">kern.geom.raid.<tt class="replaceable"><i>format</i></tt></code>. &#09;
<code class="varname">kern.geom.raid.enable</code> is to control &#09; on-disk metadata
recognition in a systemwide basis. When it &#09; is set to <tt class="literal">1</tt>, it
is enabled (the default &#09; value is <tt class="literal">1</tt>). &#09; <code
class="varname">kern.geom.raid.<tt class="replaceable"><i>format</i></tt></code> &#09;
are similar variables to control enable/disable of specific &#09; metadata or
transformation modules. The valid keywords for &#09; <code class="varname"><tt
class="replaceable"><i>format</i></tt></code> are &#09; <tt class="literal">raid0</tt>,
<tt class="literal">raid1</tt>, &#09; <tt class="literal">raid1e</tt>, <tt
class="literal">raid5</tt>, and &#09; <tt class="literal">concat</tt>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=240554"
target="_top">r240554</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=240556"
target="_top">r240556</a>]</p>

<p>The <tt class="literal">RAID</tt> &#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=geom&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">geom</span>(4)</span></a> class
now supports <tt class="literal">BIO_DELETE</tt> &#09; requests.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=243679"
target="_top">r243679</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tmpfs&sektion=5&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">tmpfs</span>(5)</span></a>
filesystem is &#09; production ready, and no longer considered an experimental &#09;
implementation.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234512"
target="_top">r234512</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tws&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">tws</span>(4)</span></a> driver
has been &#09; updated to version 10.80.00.005 from LSI.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=241763"
target="_top">r241763</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=umass&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">umass</span>(4)</span></a> driver
now &#09; supports Olympus FE-210 camera, LG UP3S MP3 player, Laser &#09; MP3-2GA13 MP3,
and Garmin GPS devices.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235086"
target="_top">r235086</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236654"
target="_top">r236654</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=xen&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">xen</span>(4)</span></a> &#09; <b
class="application">blkfront</b> driver has been fixed. &#09; It could not attach on
Citrix XenServer configurations that &#09; advertise the multi-page ring extension.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233791"
target="_top">r233791</a>]</p>
</div>

<div class="sect3">
<hr />
<h4 class="sect3"><a id="fs" name="fs">2.2.5 File Systems</a></h4>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=linprocfs&sektion=5&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">linprocfs</span>(5)</span></a>
filesystem now &#09; supports <tt class="filename">/proc/filesystems</tt>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=247808"
target="_top">r247808</a>]</p>

<p>Bugs in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=msdosfs&sektion=5&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">msdosfs</span>(5)</span></a> &#09;
which could cause mounting a FAT32 filesystem to fail, create a &#09; broken directory
entry in a FAT32 filesystem, and prevent &#09; <code class="option">sync</code> and <code
class="option">async</code> mount &#09; option from working, have been fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=246547"
target="_top">r246547</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=246548"
target="_top">r246548</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=246550"
target="_top">r246550</a>]</p>

<p>Bugs in FreeBSD NFS subsystem has been &#09; fixed. They could cause stale name cache
entries on an NFS &#09; client.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233286"
target="_top">r233286</a>]</p>

<p>A memory leak when a ZFS volume is &#09; exported via the FreeBSD NFS (<b
class="application">newnfs</b>) &#09; server has been fixed. Note that &#09; <b
class="application">oldnfs</b> is used as the default NFS &#09; implementation in <tt
class="filename">GENERIC</tt> kernel.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236147"
target="_top">r236147</a>]</p>

<p>FreeBSD NFS subsystem now supports a &#09; timeout parameter on positive name cache
entries on the NFS &#09; client side. <tt class="literal">nametimeo</tt> mount option has
&#09; been added to specify the timeout. The default value is &#09; <tt
class="literal">60</tt> seconds, and one can disable the &#09; positive name caching by
setting it to &#09; <tt class="literal">0</tt>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233327"
target="_top">r233327</a>]</p>

<p>A workaround has been implemented in &#09; FreeBSD NFS subsystem to handle a reply to
an NFS create RPC &#09; which do not include file attributes under certain &#09;
circumstances. This improves interoperability between &#09; non-FreeBSD NFS servers and
FreeBSD NFS clients.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235417"
target="_top">r235417</a>]</p>

<p>A bug in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=exports&sektion=5&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">exports</span>(5)</span></a>
handling in &#09; FreeBSD NFS subsystem has been fixed. It could cause an &#09;
unintended security configuration when there are multiple &#09; export entries with
different security flavors.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=241348"
target="_top">r241348</a>]</p>

<p>Several bugs in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nullfs&sektion=5&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">nullfs</span>(5)</span></a> which
&#09; could cause a system panic have been fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=232665"
target="_top">r232665</a>]</p>

<p>FreeBSD ZFS subsystem has &#09; been updated to support feature flags for ZFS pools
(the SPA &#09; version is 5000). Asynchronous destroy of ZFS dataset, LZ4 &#09;
compression, ZIO NOP-write optimization have been &#09; implemented as new features. <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">loader</span>(8)</span></a>
tunables &#09; <code class="varname">vfs.zfs.sync_pass_deferred_free</code>, &#09; <code
class="varname">vfs.zfs.sync_pass_dont_compress</code>, &#09; <code
class="varname">vfs.zfs.sync_pass_rewrite</code>, and &#09; <code
class="varname">vfs.zfs.nopwrite_enabled</code> have been &#09; added.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=243717"
target="_top">r243717</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=244088"
target="_top">r244088</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=247310"
target="_top">r247310</a>]</p>

<p>Note that this upgrade can cause interoperability issues &#09; when upgrading a
FreeBSD 8.4 system to 9.0 or 9.1. This is &#09; because FreeBSD 9.0 and 9.1 support SPA
version 28 and do not &#09; recognize version 5000. To mitigate this issue, the default
&#09; SPA version for a newly created ZFS pool on FreeBSD 8.4 is set &#09; to version 28.
To create a ZFS pool with version 5000, use &#09; <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=zpool&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">zpool</span>(8)</span></a> <tt
class="command">upgrade</tt> command after the &#09; creation.</p>

<p>A bug in ZFS subsystem which could &#09; cause a system panic when importing a ZFS
pool has been &#09; fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=246578"
target="_top">r246578</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">sysctl</span>(8)</span></a>
variable &#09; <code class="varname">vfs.zfs.txg.timeout</code> has been changed from
&#09; read-only to writable.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235507"
target="_top">r235507</a>]</p>
</div>
</div>

<div class="sect2">
<hr />
<h3 class="sect2"><a id="userland" name="userland">2.3 Userland Changes</a></h3>

<p>The load average limit in the &#09;<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=atrun&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">atrun</span>(8)</span></a> utility
has been set based on the number of &#09;CPUs.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=242991"
target="_top">r242991</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=chkgrp&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">chkgrp</span>(8)</span></a>
utility now supports &#09;a <code class="option">-q</code> flag to disable printing of
text when the &#09;group format is correct.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=244064"
target="_top">r244064</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=crontab&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">crontab</span>(1)</span></a>
utility now waits &#09;for a second before updating the spool directory's mtime. It
&#09;could happen that the modified crontab updated the &#09;<tt
class="literal">mtime</tt> of the spool directory, and then &#09;<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=crontab&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">crontab</span>(1)</span></a>
utility updated the <tt class="literal">mtime</tt> &#09;again within a second. In this
case, the &#09;<tt class="literal">crontab</tt> database is not updated &#09;properly.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=239877"
target="_top">r239877</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cut&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">cut</span>(1)</span></a> utility
now supports &#09;a <code class="option">-w</code> flag to specify whitespace as the
&#09;delimiter.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=244305"
target="_top">r244305</a>]</p>

<p>The default &#09;<tt class="filename">dot.cshrc</tt> file for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=csh&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">csh</span>(1)</span></a> and
&#09;<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tcsh&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">tcsh</span>(1)</span></a> has been
changed. For more detail, see &#09;<tt
class="filename">/usr/share/skel/dot.cshrc</tt>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234979"
target="_top">r234979</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=242642"
target="_top">r242642</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=daemon&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">daemon</span>(8)</span></a>
utility now supports &#09;an <code class="option">-r</code> flag to restart the program
if it has been &#09;terminated.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233762"
target="_top">r233762</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=devd&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">devd</span>(8)</span></a> daemon
now supports &#09;the <tt class="literal">!</tt> character in regex matching in &#09;<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=devd.conf&sektion=5&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">devd.conf</span>(5)</span></a>. It
inverts the logic of the &#09;matching.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=247768"
target="_top">r247768</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=devfs&sektion=5&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">devfs</span>(5)</span></a> mount
now supports &#09;<code class="option">ruleset=number</code> mount option and updating
the &#09;existing mount by using <code class="option">-u</code> flag in the &#09;<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mount&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">mount</span>(8)</span></a>
utility. This new option sets the specified &#09;ruleset number as the active ruleset of
the new devfs mount &#09;and applies all its rules at mount time. If the specified
&#09;ruleset doesn't exist, a new empty ruleset is created.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233867"
target="_top">r233867</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=du&sektion=1&manpath=FreeBSD+8.4-RELEASE"><span
 class="citerefentry"><span class="refentrytitle">du</span>(1)</span></a> utility now
supports &#09;a <code class="option">-g</code> flag to display the results in
&#09;gigabytes.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=247539"
target="_top">r247539</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fetch&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">fetch</span>(1)</span></a> utility
now supports &#09;percent-encoded strings in user and password component of a
&#09;URL.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235254"
target="_top">r235254</a>]</p>

<p>The maximum number of HTTP redirections &#09;has been increased from <tt
class="literal">5</tt> to &#09;<tt class="literal">20</tt> in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fetch&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">fetch</span>(1)</span></a>
utility.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=242034"
target="_top">r242034</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fetch&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">fetch</span>(1)</span></a> utility
now &#09;supports HTTP status codes <tt class="literal">305</tt> (Use Proxy) &#09;and <tt
class="literal">308</tt> (Permanent Redirect).[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=242288"
target="_top">r242288</a>, <a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=242291"
target="_top">r242291</a>]</p>

<p>A countermeasure against possible DoS &#09;(Denial of Service) attack described in
CVE-2010-2632 in the &#09;<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ftpd&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">ftpd</span>(8)</span></a> daemon
has been implemented.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=246357"
target="_top">r246357</a>]</p>

<p>A new environment variable &#09;<code class="varname">PROFIL_USE_PID</code> has been
added to generate &#09;profiling data for the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gprof&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">gprof</span>(1)</span></a> utility
with a filename &#09;including the process ID.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235084"
target="_top">r235084</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">ifconfig</span>(8)</span></a> now
supports a &#09;<code class="option">state</code> option for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=carp&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">carp</span>(4)</span></a> protocol
to &#09;set the state of a carp cluster. Valid state keywords are &#09;<tt
class="literal">master</tt> and &#09;<tt class="literal">backup</tt>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=243466"
target="_top">r243466</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=inetd&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">inetd</span>(8)</span></a> daemon
which &#09;could cause wrong accounting for elapsed time has been &#09;fixed.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236875"
target="_top">r236875</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=inetd&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">inetd</span>(8)</span></a> daemon
now set the &#09;listen queue size to the value of &#09;<code
class="varname">kern.ipc.somaxconn</code> instead of hardcoded value &#09;<tt
class="literal">64</tt>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=246403"
target="_top">r246403</a>]</p>

<p>The default <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ip6addrctl&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">ip6addrctl</span>(8)</span></a>
address &#09;selection policy for IPv4 and IPv6 has been updated to one in &#09;RFC
6724.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=246599"
target="_top">r246599</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kdump&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">kdump</span>(1)</span></a> utility
now supports a &#09;<code class="option">-p <tt
class="replaceable"><i>pid</i></tt></code> option to &#09;accept either a process ID or a
thread ID.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=237790"
target="_top">r237790</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=lastcomm&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">lastcomm</span>(1)</span></a>
utility now &#09;supports a <code class="option">+<tt
class="replaceable"><i>format</i></tt></code> &#09;option to specify <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=strftime&sektion=3&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">strftime</span>(3)</span></a>
format for process start &#09;and exit times.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235888"
target="_top">r235888</a>]</p>

<p>The <b class="application">libedit</b> &#09;library has been updated to a NetBSD
snapshot as of 28 &#09;December, 2009.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=237739"
target="_top">r237739</a>]</p>

<p>The <b class="application">libpmc</b> &#09;library has been updated to support more
PMCs (Performance &#09;Monitoring Counters) in Intel Core i7 and Xeon 5500 family
&#09;based on Intel documentation as of October 2011. &#09;Specifically, <tt
class="literal">DTLB_MISSES.PDE_MISS</tt> and &#09;<tt
class="literal">DTLB_MISSES.LARGE_WALK_COMPLETED</tt> have been &#09;added.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234045"
target="_top">r234045</a>]</p>

<p>The <b class="application">libradius</b> &#09;now supports the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rad_bind_to&sektion=3&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">rad_bind_to</span>(3)</span></a>
function.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234555"
target="_top">r234555</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=libusb&sektion=3&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">libusb</span>(3)</span></a>
library now supports &#09;a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=libusb_get_max_iso_packet_size&sektion=3&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span
class="refentrytitle">libusb_get_max_iso_packet_size</span>(3)</span></a> function.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235017"
target="_top">r235017</a>]</p>

<p>A bug in the the &#09;<b class="application">libutil</b> library has been fixed. It
&#09;could prevent configuration of <code class="varname">priority</code> &#09;class
capability in <tt class="filename">/etc/login.conf</tt> &#09;(<tt
class="literal">LOGIN_SETPRIORITY</tt> in &#09;<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=setusercontext&sektion=3&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span
class="refentrytitle">setusercontext</span>(3)</span></a> function) from working when the
&#09;password is not set.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233153"
target="_top">r233153</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=make&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">make</span>(1)</span></a> utility
has been &#09;updated to version <tt class="literal">8201210080</tt>. It now
&#09;supports <code class="option">-V ${<tt class="replaceable"><i>VAR</i></tt>}</code>
&#09;variable expansion, and <tt class="literal">:tu</tt> and &#09;<tt
class="literal">:tl</tt> variable modifiers.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=241368"
target="_top">r241368</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mktemp&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">mktemp</span>(1)</span></a>
utility now uses &#09;<tt class="filename">tmp</tt> as the default prefix when &#09;<code
class="option">-t</code> is not specified.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=241422"
target="_top">r241422</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mv&sektion=1&manpath=FreeBSD+8.4-RELEASE"><span
 class="citerefentry"><span class="refentrytitle">mv</span>(1)</span></a> utility now
supports a &#09;<code class="option">-h</code> flag. This forces it to treat a symbolic
&#09;link to a directory for the target as a symbolic instead of a &#09;directory.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=241321"
target="_top">r241321</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pam_exec&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">pam_exec</span>(8)</span></a>
module now supports &#09;<code class="option">return_prog_exit_status</code>. When this
option is &#09;enabled, the program exit status is used as the &#09;<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pam_exec&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">pam_exec</span>(8)</span></a>
return code. It allows the program to tell &#09;why the step failed (user unknown, for
example).[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234843"
target="_top">r234843</a>]</p>

<p>A bug in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pam_unix&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">pam_unix</span>(8)</span></a>
module has &#09;been fixed. It could prevent <code class="varname">passwordtime</code>
&#09;login capability in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=login.conf&sektion=5&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">login.conf</span>(5)</span></a>
from working.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234741"
target="_top">r234741</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pciconf&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">pciconf</span>(8)</span></a>
utility now supports &#09;a <code class="option">-e</code> flag to display PCI error
details in &#09;listing mode. When this is specified, the status of any error &#09;bits
in the PCI status register and PCI-express device status &#09;register will be displayed.
It also lists any errors indicated &#09;by version 1 of PCI-express Advanced Error
Reporting &#09;(AER).[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=237732"
target="_top">r237732</a>]</p>

<p>A workaround has been implemented in &#09;the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ppp&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">ppp</span>(8)</span></a> daemon to
support some 3G modems which return a &#09;wrong signature in echo packets and make it
impossible to use &#09;LQR and ECHO.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=242198"
target="_top">r242198</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=procstat&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">procstat</span>(1)</span></a>
utility now &#09;displays <code class="varname">osreldate</code> in binary information
&#09;for a process.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233953"
target="_top">r233953</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=procstat&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">procstat</span>(1)</span></a>
utility now &#09;displays superpage mapping flag in the process virtual memory
&#09;mappings.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=238752"
target="_top">r238752</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=procstat&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">procstat</span>(1)</span></a> and
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fstat&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">fstat</span>(1)</span></a>
&#09;utilities now shows pathname associated with a shared memory &#09;object.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236699"
target="_top">r236699</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ps&sektion=1&manpath=FreeBSD+8.4-RELEASE"><span
 class="citerefentry"><span class="refentrytitle">ps</span>(1)</span></a> utility now
supports &#09;<code class="option">cow</code> keyword to show the number of
&#09;copy-on-write faults in a process.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=236306"
target="_top">r236306</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ps&sektion=1&manpath=FreeBSD+8.4-RELEASE"><span
 class="citerefentry"><span class="refentrytitle">ps</span>(1)</span></a> utility now
supports &#09;<code class="varname">dsiz</code> and <code class="varname">ssiz</code>
keywords &#09;to show data and stack size respectively.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=241159"
target="_top">r241159</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rarpd&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">rarpd</span>(8)</span></a> daemon
now supports &#09;<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=vlan&sektion=4&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">vlan</span>(4)</span></a>
interface and <code class="option">-P</code> option to &#09;specify the PID file. When
<code class="option">-a</code> flag is &#09;specified, &#09;<tt
class="filename">/var/run/rarpd.<tt class="replaceable"><i>ifname</i></tt>.pid</tt>
&#09;is used as the PID filename by default.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=245077"
target="_top">r245077</a>]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=remquo&sektion=3&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">remquo</span>(3)</span></a>
functions &#09;where the quotient did not always have the correct sign when &#09;the
remainder was 0, and another bug that the remainder and &#09;quotient were both off by a
bit in certain cases involving &#09;subnormal remainders, have been fixed. Note that
these bugs &#09;affected all platforms except amd64 and &#09;i386.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234534"
target="_top">r234534</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rtld&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">rtld</span>(1)</span></a> dynamic
linker has been &#09;improved in performance of TLS (Thread Local Storage)
&#09;handling.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233067"
target="_top">r233067</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=setbuf&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">setbuf</span>(1)</span></a>
utility and &#09;<b class="application">libstdbuf</b> library have been added. &#09;This
controls the default buffering behavior of standard stdio &#09;streams.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235141"
target="_top">r235141</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sh&sektion=1&manpath=FreeBSD+8.4-RELEASE"><span
 class="citerefentry"><span class="refentrytitle">sh</span>(1)</span></a> program now
allows &#09;underscore characters in the arithmetic expansion.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234001"
target="_top">r234001</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sockstat&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">sockstat</span>(1)</span></a>
utility now &#09;supports a <code class="option">-j <tt
class="replaceable"><i>jid</i></tt></code> &#09;option to specify the socket list to be
limited to a specific &#09;<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jail&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">jail</span>(8)</span></a> ID.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=237672"
target="_top">r237672</a>]</p>

<p>A variable &#09;<code class="varname">NO_<tt
class="replaceable"><i>FOO</i></tt></code> in &#09;<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=src.conf&sektion=5&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">src.conf</span>(5)</span></a> now
overrides &#09;<code class="varname">WITH_<tt
class="replaceable"><i>FOO</i></tt></code>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=241969"
target="_top">r241969</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=syslogd&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">syslogd</span>(8)</span></a>
daemon now supports &#09;IPv6 destination address in &#09;<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=syslog.conf&sektion=5&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span
class="refentrytitle">syslog.conf</span>(5)</span></a>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=241472"
target="_top">r241472</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=systat&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">systat</span>(1)</span></a>
utility now accepts &#09;fractional number of seconds.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=243684"
target="_top">r243684</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tcpdrop&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">tcpdrop</span>(8)</span></a>
utility now allows &#09;addresses and ports to be separated by a colon or period
&#09;rather than a space to permit directly pasting the output of &#09;commands such as
netstat and sockstat on the command &#09;line.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=247563"
target="_top">r247563</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=top&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">top</span>(1)</span></a> utility
now displays ZFS &#09;ARC memory usage on hosts using ZFS.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=239751"
target="_top">r239751</a>]</p>

<p>A bug in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=traceroute&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">traceroute</span>(8)</span></a>
utility &#09;which could result in not accepting any incoming packets has &#09;been
fixed.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235163"
target="_top">r235163</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=unzip&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">unzip</span>(1)</span></a> program
now supports a &#09;<code class="option">-Z</code> flag to enable &#09;<b
class="application">zipinfo</b> mode.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=234331"
target="_top">r234331</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=usbdump&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">usbdump</span>(8)</span></a>
utility now supports &#09;filtering USB devices and USB endpoints.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235015"
target="_top">r235015</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=usbhidctl&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">usbhidctl</span>(1)</span></a>
utility now &#09;supports a <code class="option">-z</code> flag for reading operation. It
&#09;allows to not request current values from the device, but only &#09;receive
changes.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235881"
target="_top">r235881</a>]</p>

<p>Performance of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=zfs&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">zfs</span>(8)</span></a> &#09;<tt
class="command">list -t snapshot</tt> command has been &#09;dramatically improved.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233862"
target="_top">r233862</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=zfs&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">zfs</span>(8)</span></a> <tt
class="command">get</tt> &#09;command now supports a <code class="option">-t &#09;<tt
class="replaceable"><i>datatype</i></tt></code> option.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233862"
target="_top">r233862</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=zfs&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">zfs</span>(8)</span></a> <tt
class="command">jail</tt> &#09;and <tt class="command">unjail</tt> commands now support
&#09;a jail name as well as a jail ID.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=246750"
target="_top">r246750</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=zfs&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">zfs</span>(8)</span></a> <tt
class="command">send</tt> &#09;command now reports transmitted data size in bytes when
&#09;<code class="option">-v</code> flag is specified.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=235952"
target="_top">r235952</a>]</p>

<p>Changing <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=zfs&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">zfs</span>(8)</span></a> &#09;<tt
class="literal">canmount</tt> property to <tt class="literal">on</tt> &#09;no longer
causes remount of the &#09;ZFS dataset when a dataset is already mounted.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=237457"
target="_top">r237457</a>]</p>

<div class="sect3">
<hr />
<h4 class="sect3"><a id="rcd-scripts" name="rcd-scripts">2.3.1 <tt
class="filename">/etc/rc.d</tt> Scripts</a></h4>

<p>The <tt class="filename">rc.d</tt> scripts &#09; now display <samp
class="computeroutput">script filename &#09; running</samp> to standard error when &#09;
<tt class="literal">SIGINFO</tt> is issued. This message was sent &#09; to standard
output and could prevent redirection from &#09; working.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=232549"
target="_top">r232549</a>]</p>

<p>The <tt class="filename">rc.d/jail</tt> &#09; script now supports a <code
class="varname">jail_parameters</code> &#09; variable to specify extra parameters for
each jail.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=242083"
target="_top">r242083</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=service&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">service</span>(8)</span></a>
utility now &#09; supports a <code class="option">-R</code> flag to restart all third
party &#09; services in <tt class="filename">/usr/local/etc/rc.d</tt>.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=246609"
target="_top">r246609</a>]</p>
</div>
</div>

<div class="sect2">
<hr />
<h3 class="sect2"><a id="contrib" name="contrib">2.4 Contributed Software</a></h3>

<p><b class="application">AWK</b> has been &#09;updated to 20121220.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=246374"
target="_top">r246374</a>]</p>

<p><b class="application">ISC BIND</b> has &#09;been updated to version 9.8.4-P2.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=248807"
target="_top">r248807</a>]</p>

<p><b class="application">BZIP2</b> has &#09;been updated to version 1.0.6.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=247448"
target="_top">r247448</a>]</p>

<p><b class="application">TENEX C shell</b> &#09;(<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tcsh&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">tcsh</span>(1)</span></a>) has
been updated to version 6.18.01.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=232635"
target="_top">r232635</a>]</p>

<p><b class="application">LESS</b> &#09;(<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=less&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">less</span>(1)</span></a>) has
been updated to version v451.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=240160"
target="_top">r240160</a>]</p>

<p><b class="application">libexpat</b> has &#09;been updated to version 2.1.0.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=247514"
target="_top">r247514</a>]</p>

<p><b class="application">netcat</b> has &#09;been updated to a version as of OpenBSD
5.2.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=243819"
target="_top">r243819</a>]</p>

<p><b class="application">OpenSSH</b> has &#09;been updated to version 6.1.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=247521"
target="_top">r247521</a>]</p>

<p><b class="application">OpenSSL</b> has &#09;been updated to version 0.9.8y.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=248057"
target="_top">r248057</a>]</p>

<p><b class="application">sendmail</b> has &#09;been updated to version 8.14.7.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=250167"
target="_top">r250167</a>]</p>

<p>The <b class="application">timezone</b> &#09;database has been updated to &#09;<b
class="application">tzdata2012j</b> release.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=243006"
target="_top">r243006</a>]</p>

<p><b class="application">XZ</b> has been &#09;updated to version 5.0.4.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=245129"
target="_top">r245129</a>]</p>
</div>

<div class="sect2">
<hr />
<h3 class="sect2"><a id="ports" name="ports">2.5 Ports/Packages Collection
Infrastructure</a></h3>

<p>The <tt class="command">pkg(8)</tt> command &#09;has been added. This is used as a
bootstrap tool for &#09;<tt class="filename">ports-mgmt/pkg</tt> in the Ports
&#09;Collection.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=239563"
target="_top">r239563</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pkg_add&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">pkg_add</span>(1)</span></a>
utility now supports &#09;<code class="varname">PACKAGESUFFIX</code> to specify extension
in a &#09;package filename.[<a
href="http://svn.freebsd.org/viewvc/base?view=revision&revision=240674"
target="_top">r240674</a>]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pkg_create&sektion=1&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">pkg_create</span>(1)</span></a>
program now &#09;allows a relative pathname in the <code class="option">-p</code>
&#09;option.[<a href="http://svn.freebsd.org/viewvc/base?view=revision&revision=233686"
target="_top">r233686</a>]</p>
</div>

<div class="sect2">
<hr />
<h3 class="sect2"><a id="releng" name="releng">2.6 Release Engineering and
Integration</a></h3>

<p>The supported version of the &#09;<b class="application">KDE</b> desktop environment
(<tt class="filename">x11/kde4</tt>) has been updated from 4.7.4 &#09;to 4.10.1.</p>
</div>
</div>

<div class="sect1">
<hr />
<h2 class="sect1"><a id="upgrade" name="upgrade">3 Upgrading from previous releases of
FreeBSD</a></h2>

<p>[amd64, i386] Upgrades between RELEASE versions (and snapshots of the various security
branches) are supported using the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=freebsd-update&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span
class="refentrytitle">freebsd-update</span>(8)</span></a> utility. The binary upgrade
procedure will update unmodified userland utilities, as well as unmodified GENERIC kernel
distributed as a part of an official FreeBSD release. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=freebsd-update&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span
class="refentrytitle">freebsd-update</span>(8)</span></a> utility requires that the host
being upgraded has Internet connectivity.</p>

<p>An older form of binary upgrade is supported through the <tt
class="command">Upgrade</tt> option from the main <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysinstall&sektion=8&manpath=FreeBSD+8.4-RELEASE">
<span class="citerefentry"><span class="refentrytitle">sysinstall</span>(8)</span></a>
menu on CDROM distribution media. This type of binary upgrade may be useful on non-i386,
non-amd64 machines or on systems with no Internet connectivity.</p>

<p>Source-based upgrades (those based on recompiling the FreeBSD base system from source
code) from previous versions are supported, according to the instructions in <tt
class="filename">/usr/src/UPDATING</tt>.</p>

<div class="important">
<blockquote class="important">
<p><b>Important:</b> Upgrading FreeBSD should, of course, only be attempted after
&#09;backing up <span class="emphasis"><i class="emphasis">all</i></span> data and
configuration &#09;files.</p>
</blockquote>
</div>
</div>
</div>

<hr />
<p align="center"><small>This file, and other release-related documents, can be
downloaded from <a href="ftp://ftp.FreeBSD.org/">ftp://ftp.FreeBSD.org/</a>.</small></p>

<p align="center"><small>For questions about FreeBSD, read the <a
href="http://www.FreeBSD.org/docs.html">documentation</a> before contacting &#60;<a
href="mailto:questions@FreeBSD.org">questions@FreeBSD.org</a>&#62;.</small></p>

<p align="center"><small>For questions about this documentation, e-mail &#60;<a
href="mailto:doc@FreeBSD.org">doc@FreeBSD.org</a>&#62;.</small></p>
++++


